(* visit: 'b. 'a. (['b list] / 'a -> 'b list / 'a list) *)
let rec visit lst = match lst with
    [] -> shift (fun k -> [])
  | a :: rest -> 
      a :: shift (fun k -> (k []) :: (reset (fun () -> k (visit rest))))
in

(* prefix: 'd. 'c. (['d list] / 'c -> 'd list list / 'c) *)
let rec prefix lst = reset (fun () -> visit lst)
in

let rec length lst = match lst with
    [] -> 0
  | a :: rest -> 1 + length rest
in

(*
let ans = reset (fun () -> length (visit [1; 2; 3; 4; 5]))

(* = map length [[1]; [1; 2]; [1; 2; 3]; [1; 2; 3; 4]; [1; 2; 3; 4; 5]]
   = [1; 2; 3; 4; 5] *)

in 
let rec print_lst lst = match lst with
    [] -> ()
  | a :: rest -> print_int a; print_byte 59; print_byte 32; print_lst rest 
in
print_byte 91; 
print_lst ans;
print_byte 93;
print_newline ()
*)

let ans = prefix [1; 2; 3; 4; 5] 

(* prefix [1; 2; 3; 4; 5] *)

(* = [[1]; [1; 2]; [1; 2; 3]; [1; 2; 3; 4]; [1; 2; 3; 4; 5]] *)

in

let rec print_lst0 lst = match lst with
    [] -> ()
  | a :: rest -> print_int a; print_byte 59; print_byte 32; print_lst0 rest
in 

let rec print_lst lst = 
  (print_byte 91; print_lst0 lst; print_byte 93)
in

let rec print_lst_lst lst = match lst with
    [] -> ()
  | a :: rest -> print_lst a; print_byte 59; print_byte 32; print_lst_lst rest
in

print_byte 91; print_lst_lst ans; print_byte 93; print_newline ()
