(* reverse : 'b. 'a. ['b list] / 'b list -> 'a list / 'b list *)
let rec reverse lst = match lst with
    [] -> []
  | a :: rest ->
      shift (fun k -> a :: k (reverse rest))
in

(* f : 'a. [bool list] / 'a -> int list / 'a *)
let rec f lst = match lst with
    [] -> []
  | a :: rest -> if a then 0 :: f rest else 1 :: f rest
in

(* Note:
 * f is an identity funciton for [], but its type is bool list -> int list.
 * Since reverse always returns [], this function effectively does nothing in
 * the following program, but shows that 'a list and 'b list in reverse can
 * differ. *)

let ans = reset (fun () -> f (reverse [1; 2; 3; 4; 5]))

(* = [5; 4; 3; 2; 1] *)

in
(* print out int list *)
let rec print_lst lst = match lst with
    [] -> ()
  | a :: rest -> print_int a; print_byte 59; print_byte 32; print_lst rest

in 
print_byte 91;
print_lst ans;
print_byte 93;
print_newline () 
